#==================================================================
#
# To build CGM applications, do the following:
#
# 0. include this file in your makefile (using 'include cgm.make')
# 1. Insert '${CGM_INCLUDES}' (w/o quotes) in your compile command, e.g.
#      ${CXX} ${CGM_INCLUDES} -c mysource.cpp
# 2. Insert '${CGM_LIBS_LINK}' (w/o quotes) on your link line
#
# That's it! No need to look at the code below, unless you're curious.
#
#==================================================================

# The following are initialized here for a non-installed CGM.
# These values will be overridden when this file is installed.
CGM_INT_LDFLAGS = -L/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/.libs
CGM_INT_LTFLAGS = -R/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/.libs
CGM_INT_INCLUDE = -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1 \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/util \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/util \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/init \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/init \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/geom \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/geom \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/geom/ACIS \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/geom/virtual \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/geom/facet \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/geom/facetbool \
                  -I/cygdrive/e/users/tang/tang/mesh/GRUMMP/GRUMMP-0.6.5/cgma-12.2.0b1/geom/Cholla 

# Pre-processor flags
CGM_DEFINES =   -DTEMPLATE_DEFS_INCLUDED  
CGM_INCLUDES =  $(CGM_INT_INCLUDE)
CGM_CPPFLAGS = $(CGM_DEFINES) $(CGM_INCLUDES)

# Link flags
CGM_LIBS = -lcgm 
CGM_LDFLAGS = $(CGM_INT_LDFLAGS) 
CGM_LTFLAGS = $(CGM_INT_LTFLAGS) 
CGM_LIBS_LINK = $(CGM_LDFLAGS) $(CGM_LIBS)

# Build-generated values appended after this line

